# This file is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as 
# published by the Free Software Foundation here:
# (http://www.gnu.org/licenses/gpl-2.0.html)
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

export SRCPKG = curl
export DEPENDS = glibc,gmp,libcurl,libgnutls,libnettle,openssl,zlib
export ARCH = x86_64
export URL = http://curl.haxx.se/
BRIEF = Tool which transfers data from or to a server
DESC = curl is a command line tool and library for transferring data \
with URL syntax
SNAPVER = 5

ARCHIVE := $(PWD)/SRC/$(shell ls SRC|egrep '(bz2|gz|tar|xz)$$'|tail -1)
TYPE := $(shell file -ib $(ARCHIVE)|cut -d';' -f1|tr -d '\n')
SRCDIR := $(shell tar -tf $(ARCHIVE)|head -1|sed 's/\/.*//')
PATCHDIR := $(PWD)/SRC/patches
export VERSION := $(shell echo $(SRCDIR)|egrep -o '\-[0-9].*'| \
	sed 's/^-//')-$(SNAPVER)

LIB := $(PWD)/libcurl
LIBROOT := $(LIB)/ROOT
DEV := $(PWD)/curl-dev
DEVROOT := $(DEV)/ROOT

include /usr/share/snap/Makefile.snaplinux

$(SRCDIR)/configure: $(ARCHIVE)
	@if [ '$(TYPE)' == 'application/x-bzip2' ]; then \
		tar -jxf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-gzip' ]; then \
		tar -zxf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-tar' ]; then \
		tar -xf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-xz' ]; then \
		tar -xf $(ARCHIVE); \
	else \
		echo 'Unable to determine archive type'; \
		exit 1; \
	fi
	@touch $(SRCDIR)/configure

$(SRCDIR)/config.log: $(SRCDIR)/configure
	@cd $(SRCDIR) && \
	for patch in `find $(PATCHDIR) -name \*.patch|sort`; do \
		patch --verbose -Np1 -i $$patch; \
	done
	@cd $(SRCDIR); \
	./configure \
		--prefix=/usr \
		--disable-static \
		--enable-threaded-resolver \
		--without-ssl \
		--with-gnutls \
		--build=x86_64-snap-linux-gnu \
		--host=x86_64-snap-linux-gnu \
		--target=x86_64-snap-linux-gnu

$(SRCDIR)/src/curl: $(SRCDIR)/config.log
	@cd $(SRCDIR) && make

$(ROOT): $(SRCDIR)/src/curl
	@if [ -d $(ROOT) ]; then \
		touch $(ROOT); \
	else \
		mkdir -v $(ROOT); \
	fi

	@cd $(SRCDIR) && make install DESTDIR=$(ROOT)

	@install -v -d $(LIB)/SNAP && \
	install -v -d $(LIBROOT)/usr/lib && \
	install -v -d $(DEV)/SNAP && \
	install -v -d $(DEVROOT) && \
	mv -v $(ROOT)/usr/lib/libcurl* $(LIBROOT)/usr/lib && \
	for file in `find $(ROOT)|egrep \
	'man3\/|pkgconfig\/|\.a$$|\.h$$|\.m4$$'`; do \
		path=`dirname $$file|sed "s[$(ROOT)[$(DEVROOT)["`; \
		mkdir -vp -m 0755 $$path; \
		mv -v $$file $$path; \
	done && \
	find $(ROOT) -type d -empty -delete && \
	cd $(LIB) && make -f ../Makefile.libcurl && mv *.snap ../ && \
	cd $(DEV) && make -f ../Makefile.curl-dev && mv *.snap ../

test: $(ROOT)
	@cd $(SRCDIR); \
	src/curl --trace-ascii snaptest.txt \
		http://example.com/ > /dev/null && \
	src/curl --trace-ascii snaptest.txt --insecure \
		https://example.com/ > /dev/null && \
	src/curl --trace-ascii snaptesttime.txt \
		--trace-time http://example.com/ > /dev/null && \
	src/curl --trace-ascii snaptesttime.txt --insecure \
		--trace-time https://example.com/ > /dev/null && \
	echo; \
	echo "Tests passed"; \
	echo

clean:
	@rm -rvf $(ROOT) \
		$(DEV) \
		$(LIB) \
		$(SNAPINFO) \
		$(MANIFEST) \
		$(FILES) \
		$(SRCDIR)

